<?php

namespace App\Http\Controllers;

use Log;
use App\Model\dataPostInternal;
use App\Helper\Helper;
use Illuminate\Http\Request;

class ePcApiInvokeController extends Controller {

    private $internalApiCallObj;

    public function __construct() {

        $this->internalApiCallObj = new dataPostInternal();
    }

    /**
     * Invoke ePC internal API URL
     */
    public function invokeEpcInternalUrl() {

        $ePCResponse = $this->internalApiCallObj->invokeEpcApiUrl();
       
       if (!empty($ePCResponse)) {
           
           Log::channel('ePcApiCallLogging')->info(json_encode($ePCResponse));

       } else {

            Log::channel('ePcApiCallLogging')->info("Empty response from the ePC API URL, 
            API response:".json_encode($ePCResponse));
       }

    }

}
